package concurrency.week09;

public class Channel<T> {

	private T chan = null;

	private boolean ready = false;

	private boolean open = false;

	public synchronized void send(T value) throws InterruptedException {
		chan = value;

		ready = true;
		if (open) {
			notifyAll();
		}

		while (chan != null)
			wait();
	}

	public synchronized T recv() throws InterruptedException {
		open = true;
		while (!ready) {
			wait();
		}
		open = false;

		ready = false;

		T ret = chan;
		chan = null;

		notifyAll(); // should be notify()

		return (ret);
	}

}
