package concurrency.week09;

public class ChannelTest {

	public static void main (String[] args) throws InterruptedException{
		Channel<Integer> c = new Channel<Integer>();
		Thread ts = new Thread(new SyncSender(c));
		Thread tr = new Thread(new SyncReceiver(c));
		ts.start();
		tr.start();
		ts.join();
		tr.join();
	}

}

class SyncSender implements Runnable {

	private Channel<Integer> channel;

	SyncSender(Channel<Integer> channel) {
		this.channel = channel;
	}

	@Override
	public void run() {
		for (int i = 0; i < 100; i++) {
			try {
				Thread.sleep((long) (100*Math.random()));
				System.out.println("Sender: sent " + i);
				channel.send(new Integer(i));
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}

}

class SyncReceiver implements Runnable {

	private Channel<Integer> channel;

	SyncReceiver(Channel<Integer> channel) {
		this.channel = channel;
	}

	@Override
	public void run() {
		for (int i = 0; i < 100; i++) {
			try {
				Thread.sleep((long) (100*Math.random()));
				Integer mes = channel.recv();
				System.out.println("Receiver: received " + mes);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}

}
