package concurrency.week09;

public class Entry<R, P> {

	private CallMsg<R, P> cm;

	private Port<CallMsg<R, P>> cp = new Port<CallMsg<R, P>>();

	public P call(R req) throws InterruptedException {
		Channel<P> clientChan = new Channel<P>();
		cp.send(new CallMsg<R, P>(req, clientChan));
		return clientChan.recv();
	}

	public R accept() throws InterruptedException {
		cm = cp.recv();
		return cm.request;
	}

	public void reply(P res) throws InterruptedException {
		cm.replychan.send(res);
	}

}

class CallMsg<R, P> {
	R request;
	Channel<P> replychan;

	CallMsg(R m, Channel<P> c) {
		request = m;
		replychan = c;
	}
}
