package concurrency.week09;

public class EntryTest {

	static int NUM = 50;

	public static void main(String[] args) throws InterruptedException {
		Entry<Integer, Integer> e = new Entry<Integer, Integer>();
		Thread ts1 = new Thread(new Client(e, 0));
		Thread ts2 = new Thread(new Client(e, 1));
		Thread tr = new Thread(new Server(e));
		ts1.start();
		ts2.start();
		tr.start();
		ts1.join();
		ts2.join();
		tr.join();
	}

}

class Client implements Runnable {

	private Entry<Integer, Integer> entry;

	private int id;

	Client(Entry<Integer, Integer> entry, int id) {
		this.entry = entry;
		this.id = id;
	}

	@Override
	public void run() {
		for (int i = 0; i < EntryTest.NUM; i++) {
			try {
				Thread.sleep((long) (100 * Math.random()));
				int req = i + PortTest.NUM * id;
				System.out.println("Client " + id + ": sent " + req);
				int result = entry.call(new Integer(req));
				System.out
						.println("Client " + id + ": received back " + result);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}

}

class Server implements Runnable {

	private Entry<Integer, Integer> entry;

	Server(Entry<Integer, Integer> entry) {
		this.entry = entry;
	}

	@Override
	public void run() {
		for (int i = 0; i < EntryTest.NUM * 2; i++) {
			try {
				Thread.sleep((long) (100 * Math.random()));
				Integer mes = entry.accept();
				System.out.println("Server: received " + mes);
				int ret = mes.intValue() + 1;
				entry.reply(ret);
				System.out.println("Server: sent back " + ret);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}

}
