package concurrency.week09;

import java.util.LinkedList;

public class Port<T> {

	private LinkedList<T> queue = new LinkedList<T>();

	private int ready = 0;

	private boolean open = false;

	public synchronized void send(T value) throws InterruptedException {
		queue.addLast(value);

		ready++;
		if (open) {
			notifyAll();
		}

	}

	public synchronized T recv() throws InterruptedException {
		open = true;
		while (ready == 0) {
			wait();
		}
		open = false;

		ready--;

		return queue.removeFirst();
	}

}
