package concurrency.week09;

public class PortTest {

	static int NUM = 50;

	public static void main(String[] args) throws InterruptedException {
		Port<Integer> c = new Port<Integer>();
		Thread ts1 = new Thread(new AsyncSender(c, 0));
		Thread ts2 = new Thread(new AsyncSender(c, 1));
		Thread tr = new Thread(new AsyncReceiver(c));
		ts1.start();
		ts2.start();
		tr.start();
		ts1.join();
		ts2.join();
		tr.join();
	}

}

class AsyncSender implements Runnable {

	private Port<Integer> port;

	private int id;

	AsyncSender(Port<Integer> channel, int id) {
		this.port = channel;
		this.id = id;
	}

	@Override
	public void run() {
		for (int i = 0; i < PortTest.NUM; i++) {
			try {
				Thread.sleep((long) (100 * Math.random()));
				int req = i + PortTest.NUM*id;
				System.out.println("Sender " + id + ": sent " + req);
				port.send(new Integer(req));
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}

}

class AsyncReceiver implements Runnable {

	private Port<Integer> port;

	AsyncReceiver(Port<Integer> channel) {
		this.port = channel;
	}

	@Override
	public void run() {
		for (int i = 0; i < PortTest.NUM * 2; i++) {
			try {
				Thread.sleep((long) (100 * Math.random()));
				Integer mes = port.recv();
				System.out.println("Receiver: received " + mes);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}

}